
from PySteppables import *
import CompuCell
import sys
class SortingSteppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=1):
        SteppableBasePy.__init__(self,_simulator,_frequency)
        
    def start(self):
        
        self.cellField[50:52,50:52,0] = self.newCell(self.CONDENSING) 
        
        
        
        for cell in self.cellList:
            cell.targetVolume = 25.0
            cell.lambdaVolume = 2.0
        
#         for cell in self.cellList:
# #             if cell.yCOM < self.dim.y/2:
#             if cell.yCOM < 50:
#                 cell.type = self.NONCONDENSING
#             else:
#                cell.type = self.CONDENSING                
            
            

        
        
        
    def step(self,mcs):        
        for cell in self.cellList:
            if cell.id >= 1 and cell.id<=10:
                cell.targetVolume += 1
                
#                 print dir(cell)
        
        
    def finish(self):
        # Finish Function gets called after the last MCS
        pass
        
from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
import CompuCell
import sys

from PlayerPython import *
from math import *


class Mitosis(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
    
    def step(self,mcs):
        # print "INSIDE Mitosis"
        cells_to_divide=[]
        
        for cell in self.cellList:
            if cell.volume>50:
                
                cells_to_divide.append(cell)
                
        for cell in cells_to_divide:
            # to change mitosis mode leave one of the below lines uncommented
            self.divideCellRandomOrientation(cell)
            # self.divideCellOrientationVectorBased(cell,1,0,0)                 # this is a valid option
            # self.divideCellAlongMajorAxis(cell)                               # this is a valid option
            # self.divideCellAlongMinorAxis(cell)                               # this is a valid option

    def updateAttributes(self):
        self.parentCell.targetVolume /= 2.0 # reducing parent target volume                 
        self.cloneParent2Child()            
        
        # for more control of what gets copied from parent to child use cloneAttributes function
        # self.cloneAttributes(sourceCell=self.parentCell, targetCell=self.childCell, no_clone_key_dict_list = [attrib1, attrib2] )
        
        from random import random, randint   
        
        if random()<0.3:
            self.childCell.type = self.NONCONDENSING
#         if self.parentCell.type==1:
#             self.childCell.type=2
#         else:
#             self.childCell.type=1
        
